// ignore_for_file:  constant_identifier_names

import 'package:fis_measure/configs/patient.dart';
import 'package:fis_measure/interfaces/enums/species.dart';

class UrologyFormulas {
  UrologyFormulas._();
  static final IUrologyFormulaStrategy _singleton =
      GlobalPatientConfig.speciesType == SpeciesType.mouse
          ? BaseUrologyFormulas()
          : AnimalsUrologyFormulas();

  static double calcRUV(double d1, double d2) {
    return _singleton.calcRUV(d1, d2);
  }
}

abstract class IUrologyFormulaStrategy {
  double calcRUV(double d1, double d2);
}

class BaseUrologyFormulas implements IUrologyFormulaStrategy {
  /// 计算残余尿
  @override
  double calcRUV(double d1, double d2) {
    double ruv = d1 * d2 * 5.9 - 14.9;
    return ruv < 0 ? 0 : ruv;
  }
}

class AnimalsUrologyFormulas extends BaseUrologyFormulas {}
