import 'package:fis_measure/interfaces/process/calculators/values.dart';
import 'package:fis_measure/process/calcuators/calculator.dart';
import 'package:fis_measure/process/items/item.dart';
import 'package:fis_measure/process/primitives/urm_measure/urm_two_rect_den.dart';

class AbRatioCal extends Calculator<TwoURMRectDen, double> {
  AbRatioCal(TwoURMRectDen ref) : super(ref);

  @override
  void calculate() {
    if (ref.feature == null) return;

    final a1 = _pickChildValue(ref.child1);
    final a2 = _pickChildValue(ref.child2);

    final feature = ref.feature!;
    final viewport = feature.hostVisualArea!.viewport!;

    // if (a1 != null && a2 != null) {
    //   final value = GeneralFormulas.countStenosis(
    //     a1,
    //     a2,
    //   );
    //   updateFloatValue(value);
    // }
  }

  double? _pickChildValue(MeasureItem item) {
    if (item.calculator == null) return null;
    ValueBase? value;
    if (item.measuredFeatures.isNotEmpty) {
      value = item.measuredFeatures.first.value;
    } else if (item.feature != null) {
      value = item.feature!.value;
    }
    if (value != null && value is FloatValue) {
      return (value).value ?? 0;
    }
    return null;
  }
}

class TwoURMRectDenCal extends Calculator<TwoURMRectDen, double> {
  TwoURMRectDenCal(TwoURMRectDen ref) : super(ref);

  @override
  void calculate() {
    if (ref.feature == null) return;

    final a1 = _pickChildValue(ref.child1);
    final a2 = _pickChildValue(ref.child2);

    final feature = ref.feature!;
    final viewport = feature.hostVisualArea!.viewport!;

    // if (a1 != null && a2 != null) {
    //   final value = GeneralFormulas.countStenosis(
    //     a1,
    //     a2,
    //   );
    //   updateFloatValue(value);
    // }
  }

  double? _pickChildValue(MeasureItem item) {
    if (item.calculator == null) return null;
    ValueBase? value;
    if (item.measuredFeatures.isNotEmpty) {
      value = item.measuredFeatures.first.value;
    } else if (item.feature != null) {
      value = item.feature!.value;
    }
    if (value != null && value is FloatValue) {
      return (value).value ?? 0;
    }
    return null;
  }
}

class TwoURMTraceDenCal extends Calculator<TwoURMTraceDen, double> {
  TwoURMTraceDenCal(TwoURMTraceDen ref) : super(ref);

  @override
  void calculate() {
    if (ref.feature == null) return;

    final a1 = _pickChildValue(ref.child1);
    final a2 = _pickChildValue(ref.child2);

    final feature = ref.feature!;
    final viewport = feature.hostVisualArea!.viewport!;

    // if (a1 != null && a2 != null) {
    //   final value = GeneralFormulas.countStenosis(
    //     a1,
    //     a2,
    //   );
    //   updateFloatValue(value);
    // }
  }

  double? _pickChildValue(MeasureItem item) {
    if (item.calculator == null) return null;
    ValueBase? value;
    if (item.measuredFeatures.isNotEmpty) {
      value = item.measuredFeatures.first.value;
    } else if (item.feature != null) {
      value = item.feature!.value;
    }
    if (value != null && value is FloatValue) {
      return (value).value ?? 0;
    }
    return null;
  }
}

class TwoURMEllipseDenCal extends Calculator<TwoURMEllipseDen, double> {
  TwoURMEllipseDenCal(TwoURMEllipseDen ref) : super(ref);

  @override
  void calculate() {
    if (ref.feature == null) return;

    final a1 = _pickChildValue(ref.child1);
    final a2 = _pickChildValue(ref.child2);

    final feature = ref.feature!;
    final viewport = feature.hostVisualArea!.viewport!;

    // if (a1 != null && a2 != null) {
    //   final value = GeneralFormulas.countStenosis(
    //     a1,
    //     a2,
    //   );
    //   updateFloatValue(value);
    // }
  }

  double? _pickChildValue(MeasureItem item) {
    if (item.calculator == null) return null;
    ValueBase? value;
    if (item.measuredFeatures.isNotEmpty) {
      value = item.measuredFeatures.first.value;
    } else if (item.feature != null) {
      value = item.feature!.value;
    }
    if (value != null && value is FloatValue) {
      return (value).value ?? 0;
    }
    return null;
  }
}

class TwoURMRectFractalCal extends Calculator<TwoURMRectFractal, double> {
  TwoURMRectFractalCal(TwoURMRectFractal ref) : super(ref);

  @override
  void calculate() {
    if (ref.feature == null) return;

    final a1 = _pickChildValue(ref.child1);
    final a2 = _pickChildValue(ref.child2);

    final feature = ref.feature!;
    final viewport = feature.hostVisualArea!.viewport!;

    // if (a1 != null && a2 != null) {
    //   final value = GeneralFormulas.countStenosis(
    //     a1,
    //     a2,
    //   );
    //   updateFloatValue(value);
    // }
  }

  double? _pickChildValue(MeasureItem item) {
    if (item.calculator == null) return null;
    ValueBase? value;
    if (item.measuredFeatures.isNotEmpty) {
      value = item.measuredFeatures.first.value;
    } else if (item.feature != null) {
      value = item.feature!.value;
    }
    if (value != null && value is FloatValue) {
      return (value).value ?? 0;
    }
    return null;
  }
}

class TwoURMTraceFractalCal extends Calculator<TwoURMTraceFractal, double> {
  TwoURMTraceFractalCal(TwoURMTraceFractal ref) : super(ref);

  @override
  void calculate() {
    if (ref.feature == null) return;

    final a1 = _pickChildValue(ref.child1);
    final a2 = _pickChildValue(ref.child2);

    final feature = ref.feature!;
    final viewport = feature.hostVisualArea!.viewport!;

    // if (a1 != null && a2 != null) {
    //   final value = GeneralFormulas.countStenosis(
    //     a1,
    //     a2,
    //   );
    //   updateFloatValue(value);
    // }
  }

  double? _pickChildValue(MeasureItem item) {
    if (item.calculator == null) return null;
    ValueBase? value;
    if (item.measuredFeatures.isNotEmpty) {
      value = item.measuredFeatures.first.value;
    } else if (item.feature != null) {
      value = item.feature!.value;
    }
    if (value != null && value is FloatValue) {
      return (value).value ?? 0;
    }
    return null;
  }
}

class TwoURMEllipseFractalCal extends Calculator<TwoURMEllipseFractal, double> {
  TwoURMEllipseFractalCal(TwoURMEllipseFractal ref) : super(ref);

  @override
  void calculate() {
    if (ref.feature == null) return;

    final a1 = _pickChildValue(ref.child1);
    final a2 = _pickChildValue(ref.child2);

    final feature = ref.feature!;
    final viewport = feature.hostVisualArea!.viewport!;

    // if (a1 != null && a2 != null) {
    //   final value = GeneralFormulas.countStenosis(
    //     a1,
    //     a2,
    //   );
    //   updateFloatValue(value);
    // }
  }

  double? _pickChildValue(MeasureItem item) {
    if (item.calculator == null) return null;
    ValueBase? value;
    if (item.measuredFeatures.isNotEmpty) {
      value = item.measuredFeatures.first.value;
    } else if (item.feature != null) {
      value = item.feature!.value;
    }
    if (value != null && value is FloatValue) {
      return (value).value ?? 0;
    }
    return null;
  }
}
