import 'package:fis_measure/define.dart';
import 'package:fis_measure/view/ai_result_modifier/controller.dart';
import 'package:fis_ui/index.dart';
import 'package:flutter/material.dart';
import 'package:get/get.dart';

/// AI 下标切换器
class AiIndexTag extends FStatelessWidget {
  const AiIndexTag({super.key});

  @override
  FWidget build(BuildContext context) {
    return FisBuilder<AiResultModifierController>(
      id: 'ai_index_tag',
      builder: (_) {
        return SizedBox(
          height: 38,
          child: FRow(
            children: [
              FExpanded(child: _buildAiDetectedObjects(_)),
              FInkWell(
                onTap: () => Get.back(),
                child: const FIcon(
                  Icons.close,
                  color: Colors.white,
                ),
              )
            ],
          ),
        );
      },
    );
  }

  /// 多个病灶的下标
  FWidget _buildAiDetectedObjects(AiResultModifierController controller) {
    if (controller.aiDetectedObjectList.length > 1) {
      return FContainer(
        alignment: Alignment.centerLeft,
        child: FWrap(
          spacing: 2.0, // 主轴(水平)方向间距
          runSpacing: 2.0, // 纵轴（垂直）方向间距
          direction: Axis.horizontal,
          alignment: WrapAlignment.start,
          children: List<FWidget>.generate(
            controller.aiDetectedObjectList.length,
            (index) {
              return FInkWell(
                onTap: () {
                  controller.changeAiDetectedObjectIndex(index);
                },
                child: FContainer(
                  decoration: BoxDecoration(
                    color: controller.currentAiDetectedObjectIndex == index
                        ? const Color.fromRGBO(54, 169, 206, 1)
                        : Colors.grey,
                  ),
                  width: 38,
                  height: 35,
                  child: FCenter(
                    child: FText(
                      '${index + 1}',
                      style: const TextStyle(
                        color: Colors.white,
                      ),
                    ),
                  ),
                ),
              );
            },
          ),
        ),
        color: Colors.transparent,
      );
    } else {
      return const FSizedBox();
    }
  }
}
